
EnableExplicit

;XIncludeFile "C:\pbi\increaseFilename.pbi"
;{ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\ C:\pbi\increaseFilename.pbi
        ; increaseFilename.pbi
        
        
        ; um zu verhindern dass dateien berschrieben
        ; oder ersetzt werden.
        ; gibt den nchsten im dateisystem noch nicht
        ; benutzten dateinamen zurck ausgehend vom
        ; bergebenen dateinamen (file.s) und
        ; entsprechend der folge:
        
        ; dateiname.abc
        ; dateiname(2).abc
        ; dateiname(3).abc
        ; dateiname(4).abc
        ; dateiname(...).abc
        Procedure.s increaseFilename(file.s)
          Protected path.s
          Protected ext.s
          Protected fullname.s
          Protected name.s
          Protected i.l
          If FileSize(file)>=0
            path=GetPathPart(file)
            fullname=GetFilePart(file)
            ext=GetExtensionPart(file)
            name=Left( fullname, Len(fullname)-Len(ext)-1 )
            i=2
            While FileSize( path + name + "(" + Str(i) + ")." + ext ) >= 0
              i+1
            Wend
            file= path + name + "(" + Str(i) + ")." + ext
          EndIf
          ProcedureReturn file
        EndProcedure 
        
        
        ; [...]
;}
;  ________________________________/ [end] C:\pbi\increaseFilename.pbi



SetCurrentDirectory( GetPathPart(ProgramFilename()) )

Enumeration
  #win
  #comboComm
  #comboFile
  #textCommm
  #textFile
  #buttOk
  #buttCancel
  #menuEsc
  #menuReturn
EndEnumeration

NewList filelist.s()
NewList history_commands.s()
NewList history_filenames.s()
Define command.s
Define path.s
Define line.s
Define hWin.l, ev.l, eg.l, em.l, quit.l
Define i.l, switch.l
Define inifile.s = GetCurrentDirectory()+"PB_Projecz.ini"
Define batfile.s


Macro GET_FILELIST()
  If CountProgramParameters() = 0
    MessageRequester("error", "PB_Projecz needs file(s) as paramter(s)")
    End
  EndIf
  
  For i=1 To CountProgramParameters()
    AddElement(filelist())
    filelist() = ProgramParameter()
    ;MessageRequester("",filelist())
  Next
EndMacro


Macro READ_HISTORY()
  If ReadFile(0,inifile)
    switch = 0
    While Not Eof(0)
      line.s = ReadString(0)
      If line = "==="
        switch = 1
      ElseIf line
        Select switch
        Case 0
          AddElement(history_commands())
          history_commands() = line
        Case 1
          AddElement(history_filenames())
          history_filenames() = line
        EndSelect
      EndIf
    Wend
    CloseFile(0)
  Else
    MessageRequester("notice","can't find *.ini"+#CRLF$+inifile+#CRLF$)
  EndIf

  If Not CountList(history_commands())
    AddElement(history_commands())
    history_commands() = "start C:\Programme\PureBasic\PureBasic.exe %filenamelist%"
  EndIf
  If Not CountList(history_filenames())
    AddElement(history_filenames())
    history_filenames() = "PBProject.bat"
  EndIf
EndMacro


Macro WRITE_HISTORY()
  If CreateFile(0,inifile)

    i=0
    ForEach history_commands()
      If i<15
        WriteStringN(0,history_commands())
      EndIf
      i+1
    Next

    WriteStringN(0,"===")

    i=0
    ForEach history_filenames()
      If i<15
        WriteStringN(0,history_filenames())
      EndIf
      i+1
    Next

    CloseFile(0)
  Else
    MessageRequester("error","can't write "+#CRLF$+inifile)
  EndIf
EndMacro


Macro add_to_list(item,linkedlist)
  ForEach linkedlist
    If linkedlist = item
      DeleteElement(linkedlist)
    EndIf
  Next
  ResetList(linkedlist)
  AddElement(linkedlist)
  linkedlist = item
EndMacro


Macro WRITE_BAT()
  ;MessageRequester("",batfile)
  If CreateFile(1,path+batfile)
    WriteStringN(1,"set filenamelist="+Chr(34)+Chr(34))
    WriteStringN(1,"")
    ForEach filelist()
      WriteStringN(1,"set filenamelist=%filenamelist% "+Chr(34)+GetFilePart(filelist())+Chr(34))
    Next
    WriteStringN(1,"")
    WriteStringN(1,command)
    WriteStringN(1,"")
    CloseFile(1)
  Else
    MessageRequester("error","can't create file:"+#CRLF$+batfile)
    End
  EndIf
EndMacro


Macro CHECK_DATA()
  command = GetGadgetText(#comboComm)
  batfile = GetGadgetText(#comboFile)
  quit = 1
  If FileSize(path+batfile) >= 0
    If #PB_MessageRequester_No = MessageRequester("confirm..", path+batfile+#CRLF$+"already exists. overwrite?",#PB_MessageRequester_YesNo)
      ;batfile = GetFilePart( increaseFilename(path+batfile) )
      ;AddGadgetItem(#comboFile,1,batfile)
      ;SetGadgetState(#comboFile,1)
      quit = 0
    EndIf
  EndIf
  add_to_list(command, history_commands())
  add_to_list(batfile, history_filenames())
EndMacro


Macro SET_GUI()
  hWin = OpenWindow(#win, 200,200, 600,100,"pb projectz", #PB_Window_ScreenCentered | #PB_Window_MinimizeGadget)
  CreateGadgetList(hWin)
  
    ComboBoxGadget(#comboComm, 105,5, 500-8,200, #PB_ComboBox_Editable)
    ComboBoxGadget(#comboFile, 105,35, 500-8,200, #PB_ComboBox_Editable)
    ForEach history_commands()
      AddGadgetItem(#comboComm,-1,history_commands())
    Next
    ForEach history_filenames()
      AddGadgetItem(#comboFile,-1,history_filenames())
    Next
    SetGadgetState(#comboComm,0)
    SetGadgetState(#comboFile,0)
  
    TextGadget(#textCommm, 5,5, 90,20, "command:", #PB_Text_Right)
    TextGadget(#textFile, 5,35, 90,20, "filename:", #PB_Text_Right)
    ButtonGadget(#buttOk, 105,65, 100,20, "ok")
    ButtonGadget(#buttCancel, 215,65, 100,20, "cancel")
  
  AddKeyboardShortcut(#win, #PB_Shortcut_Escape, #menuEsc)
  AddKeyboardShortcut(#win, #PB_Shortcut_Return, #menuReturn)
EndMacro





;{ --- RUN (main)

GET_FILELIST()
READ_HISTORY()

;SET_GUI()

  hWin = OpenWindow(#win, 200,200, 600,100,"pb projectz", #PB_Window_ScreenCentered | #PB_Window_MinimizeGadget)
  CreateGadgetList(hWin)
  
    ComboBoxGadget(#comboComm, 105,5, 500-8,200, #PB_ComboBox_Editable)
    ComboBoxGadget(#comboFile, 105,35, 500-8,200, #PB_ComboBox_Editable)
    ForEach history_commands()
      AddGadgetItem(#comboComm,-1,history_commands())
    Next
    ForEach history_filenames()
      AddGadgetItem(#comboFile,-1,history_filenames())
    Next
    SetGadgetState(#comboComm,0)
    SetGadgetState(#comboFile,0)
  
    TextGadget(#textCommm, 5,5, 90,20, "command:", #PB_Text_Right)
    TextGadget(#textFile, 5,35, 90,20, "filename:", #PB_Text_Right)
    ButtonGadget(#buttOk, 105,65, 100,20, "ok")
    ButtonGadget(#buttCancel, 215,65, 100,20, "cancel")
  
  AddKeyboardShortcut(#win, #PB_Shortcut_Escape, #menuEsc)
  AddKeyboardShortcut(#win, #PB_Shortcut_Return, #menuReturn)



FirstElement(filelist())
FirstElement(history_filenames())
path.s = GetPathPart(filelist())
batfile.s = history_filenames()


Repeat
  ev = WaitWindowEvent(100)
  eg = EventGadget()
  em = EventMenu()
  If (ev=#PB_Event_CloseWindow)  Or  (ev=#PB_Event_Menu And em=#menuEsc)  Or  (ev=#PB_Event_Gadget And eg=#buttCancel)
    quit = 1
  ElseIf (ev=#PB_Event_Menu And em=#menuReturn)  Or  (ev=#PB_Event_Gadget And eg=#buttOk)
    CHECK_DATA()
    WRITE_HISTORY()
    If quit
      WRITE_BAT()
    EndIf
  EndIf
Until quit

End
;} ---













; IDE Options = PureBasic 4.50 Beta 4 (Windows - x86)
; CursorPosition = 3
; Folding = x+
; Executable = PB_Projecz.exe
; HideErrorLog
; CompileSourceDirectory